	program etacha
cc******************************************************************
cc*** Version micro avec makefile du programme ETACHA (18/12/91) ***
cc******************************************************************
cc
cc   VERSION du 06/06/95 (dernieres corrections : 04/03/97)
cc
cc   Modifi le 26/2/94 pour prendre en compte les lectrons M
cc   et l'effet Auger
cc
cc   Modifi le 24/3/94 pour tenir compte de la perte d'nergie
cc
cc   Modifi le 26/4/94 pour volution avec la charge moyenne
cc
cc   Modifi le 09/9/94 pour corrections de saturation et d'anticrantage
cc
cc   Contact: J.P.ROZET  eMail:rozet@gps.jussieu.fr
cc
cc	   Calcule les tats de charge et leur volution en fonction
cc	de l'paisseur de cible traverse pour un nombre d'lectrons
cc	initial =< 28. Les couches 1s,2s et 2p sont seules
cc	prises en compte dans un premier temps , et les couches 3s,3p
cc	et 3d traites  part. Ce programme rsoud un systme de 84
cc	quations diffrentielles couples : 63 dcrivent l'volution
cc	d' tats "corrlls" du type Y(i,j,k) o i,j et k reprsentent le
cc	nombre d'lectrons dans chacun des sous-tats 2p,2s et 1s
cc	(i entre 0 et 6, j et k entre 0 et 2) et 21 dcrivent celles
cc	des tats 3s (3 quations), 3p (7 quations) et 3d (11 quations).
cc	L'intgration des quations diffrentielles se fait par la
cc	mthode de Runge-Kutta en utilisant le programme QDIFF et
cc	ses subroutines associes (amlioration du code d' Adams -
cc	predictor-corrector method d'ordre variable)
cc	***********************************************************
	dimension Y(84),YX(84),WORK(8700),IWORK(110),PR(30),
     s	PKL(20),PM(20)
	character nomf*14
	common/etats/ICO(63)
	common/seceff/sec(26),cor(38),secs(38)
	common/secrad/Rad,ok,ol,Rad3s,Rad3p1,Rad3p2,Rad3d
	common/tol/ep0,ep1,erel,erabs
	common/aug/AKLL,AKLM,ALMM
	common/mean/y1s,y2s,y2p,y3s,y3p,y3d,yl,ym,ymp,ymm
	common/qmoy/ykm,yl1m,yl2m,ym1m,ym2m
	common/popi/n02s,n02p,n03s,n03p,n03d,nl0,nm0
	common/par4/zk,zl1,zl2,zm1,zm2,tetak,tetal1,tetal2,tetam1,tetam2
        external F
cc      ***********************************************************
cc	initialisations et lecture des donnes
cc	***********************************************************
	ilgn=64
	iprt=1
	NEQ=84
	iflag=1
	icor=0
	call ini(ICO)
 20	call donaut(QP,Z1,AP,EP,Z2,AC,RHO,EPM,iflag,E1,S1,E2,S2,
     s	istp,iprt,ilgn)
	if (iflag.eq.2) then
	write (6,*) 'iflag=2 !! Input data file problem'
	goto 5000
	endif
	ilp=ilgn-55
	do 21 i=1,38
	  if (cor(i).ne.1.) then
	    icor=1
	  end if
 21	continue
	if (icor.eq.1) then
	ilp=ilp-2
	end if
	pas0=20.*ep0
	zp=z1
	ip=zp
	e=ep
	zc=z2
	VC=(1-(1+E/931.5)**(-2))**(0.5)
	VU=137.036*VC
	ok=omk(zp)
	ol=oml(zp)
cc....... coefficients pour le ralentissement ..........
	if(istp.eq.0) then
	  tc=1.e9
	  as=0.
	  bs=e
cc.......!!!
	else
	  as=(s2-s1)/((e2-e1)*ap)
	  bs=(s2*e1-s1*e2)/(s2-s1)
	  stp=s1+(e-E1)*(s2-s1)/(e2-e1)
	  if(stp.lt.0.) then
	  write(6,*)' '
	  write(6,*)' '
	  write(6,*)' stp=',stp
	  STOP' problem with stopping power values, end of calculation'
	  end if
	  stp1=log10(ap*e/stp)
	  astp=10.**aint(stp1)
	  if (stp1.lt.0.) then
	    astp=astp/10.
	  end if
	  sstp=ap*e/(stp*astp)
	  if (sstp.le.1.5) then
	    tc=5.*astp
	  else if (sstp.le.3.5) then
	    tc=10.*astp
	  else if (sstp.lt.7.) then
	    tc=20.*astp
	  else
	    tc=50.*astp
	  end if
	end if
	if (zp.le.20) then
	  ddq=4.
	  if (erel.gt.1.e-4) then
	    ddq=ddq/2.
	  end if
	else if (zp.le.40) then
	  ddq=2.
	  if (erel.gt.1.e-4) then
	    ddq=ddq/2.
	  end if
	else
	  ddq=1.
	end if
	write (6,*) 'initialization of populations'
cc	***** calcul des populations de l'atome neutre ***********
	n02s=0
	n02p=0
	n03s=0
	n03p=0
	n03d=0
	if (IP.le.2) then
	continue
	elseif (IP.le.4) then
	n02s=IP-2
	elseif (IP.le.10) then
	n02s=2
	n02p=IP-4
	elseif (IP.le.12) then
	n02s=2
	n02p=6
	n03s=IP-10
	elseif (IP.le.18) then
	n02s=2
	n02p=6
	n03s=2
	n03p=IP-12
	elseif (IP.le.28) then
	n02s=2
	n02p=6
	n03s=2
	n03p=6
	n03d=IP-18
	else
	n02s=2
	n02p=6
	n03s=2
	n03p=6
	n03d=10
	endif
	nl0=n02s+n02p
	nm0=n03s+n03p+n03d
cc	***** initialisation de Y(n) *****************************
	do 1 n=1,84
	Y(n)=0.
  1	continue
	NEL=ZP-QP
	if (NEL.le.2) then
		N=NUM(NEL)
		Y(N)=1.
	else if (NEL.le.4) then
		N=NUM(NEL*10-18)
		Y(N)=1.
	else if (NEL.le.10) then
		N=NUM(NEL*100-378)
		Y(N)=1.
	else
		Y(63)=1.
	endif
	if (NEL.lt.10) then
	Y(64)=1.
	Y(67)=1.
	Y(74)=1.
	elseif (NEL.lt.13) then
	Y(54+NEL)=1.
	Y(67)=1.
	Y(74)=1.
	elseif (NEL.lt.19) then
	Y(55+NEL)=1.
	Y(66)=1.
	Y(74)=1.
	elseif (NEL.lt.29) then
	Y(56+NEL)=1.
	Y(66)=1.
	Y(73)=1.
	else
	write (6,*) ' '
	write (6,*) '**************************************************'
	write (6,*) ' too much electrons ...'
	write (6,*) ' try again with ZP-Q < 29'
	write (6,*) '**************************************************'
	write (6,*) ' '
	go to 20
	endif
cc	******************************************************************
cc	*** calcul des sections radiatives et Auger (unit 10e-20 cm) ***
	conv=6.023E-3/AC
	RAD=3.461E-6*(Zk*tetak)**4*AC/(RHO*VC)/2.
	RAD3s=.034891E-6*(Zk*tetak)**4*AC/(RHO*VC)/6.
	RAD3p=1.0301E-6*(Zk*tetak)**4*AC/(RHO*VC)/2.
	RAD3d=.3544E-6*(Zk*tetak)**4*AC/(RHO*VC)/6.
	if (n02p.ge.1) then
	AKLL=rad*(1./ok-1.)*n02p/(nl0*(nl0-1))
	else
	AKLL=1000.*rad
	endif
	if (nm0.ge.1) then
	AKLM=rad3p*0.882*(1./ok-1.)*n02p/(nl0*nm0)
	else
	AKLM=1000.*rad3p
	endif
	if (nm0.ge.2) then
	ALMM=(rad3s*n03s+rad3d*n03d)*(1./ol-1.)/(nm0*(nm0-1))
	else
	ALMM=1000.*rad3s
	endif
cc	***************************************************************
cc	Ouverture et en-tte des fichiers
cc	***************************************************************
	call getdat(iyr,imon,iday)
cc ....................................................................
200	format(2x,i2.2,1h/,i2.2,1h/,i4,42x,3h(C),2x,8hGPS-PIIM,2x,
     s	9hJPR 03/97)
201	format(/,33x,A14,/)
202	format(80('*'),//,
     s	17x,49('*'),/,17x1h*,47x1h*,/,17x1h*,4x4h****,2x5h*****,
     s	2x5h*****,2x5h*****,2x1h*,3x1h*,2x,5h*****,4x1h*,/,
     s	17x1h*,4x1h*,7x1h*,4x1h*,3x1h*,2x1h*,6x1h*,3x1h*,2x1h*,3x1h*,
     s	4x1h*,/,17x1h*,4x1h*,7x1h*,4x1h*,3x1h*,2x1h*,6x1h*,3x1h*,2x1h*,
     s	3x1h*,4x1h*,/,17x1h*,4x4h****,4x1h*,4x5h*****,2x1h*,6x5h*****,
     s	2x5h*****,4x1h*,/,17x1h*,4x1h*,7x1h*,4x1h*,3x1h*,2x1h*,6x1h*,
     s	3x1h*,2x1h*,3x1h*,4x1h*,/,17x1h*,4x1h*,7x1h*,4x1h*,3x1h*,2x1h*,
     s	6x1h*,3x1h*,2x1h*,3x1h*,4x1h*,/,
     s	17x1h*,4x4h****,4x1h*,4x1h*,3x1h*,2x5h*****,2x1h*,3x1h*,2x1h*,
     s	3x1h*,4x1h*,/,17x1h*,47x1h*,/,17x,49('*'),//)
203	format(80('*'))
204	format(2x26hPROJECTILE: atomic number=,f4.0,2x,
     s	16hincident charge=,f4.0,2x12hatomic mass=f4.0,/,
     s	16x16hincident energy=,f8.3,6h MeV/u,2x9hvelocity=,f8.3,5h (au),
     s	//,6x22hTARGET: atomic number=,f4.0,2x6hatomic,
     s	6h mass=,f4.0,2x8hdensity=,f6.3,6h g/cm3,/)
205	format(15x15hrelative error=,g11.4,3x9habsolute=,g11.4,/)
206	format(26x28hNo stopping power correction,/,26x,28('-'))
207	format(11x16hEnergy loss: S1=,f8.3,17hMeV/mg/cm at E1=,f8.3,
     s	5hMeV/u,/,19x8hand: S2=,f8.3,17hMeV/mg/cm at E2=,f8.3,5hMeV/u)
208	FORMAT(/,13x,54('-'),/,13x33hReference ("hydrogenic") cross se,
     s	21hctions in 10E-20 cm:,/,13x,54('-'),//,2x11hCAPTURE TO:,
     s	2x46h( substates of fully stripped ions, MEC only ),/,
     s	21x4h1s =,G9.3,2x4h2s =,G9.3,2x4h2p =,G9.3,/,21x4h3s =,
     s	G9.3,2x4h3p =,G9.3,2x4h3d =,G9.3,/,2x7hREC TO:,6x,
     s	42h(will be added to previous cross sections),/,21x4h1s =,
     s	G9.3,2x4h2s =,G9.3,2x4h2p =,G9.3,/,21x4h3s =,G9.3,
     s	2x4h3p =,G9.3,2x4h3d =,G9.3,//,
     s	13x41hIonization and excitation of hydrogenlike,
     s	12h projectile,,/,12x31hcorrected for "saturation" and ,
     s	25hscreening + antiscreening,//,2x14hIONIZATION OF:,5x4h1s =,
     s	G9.3,2x4h2s =,G9.3,2x4h2p =,G9.3,/,21x4h3s =,G9.3,2x4h3p =,
     s	G9.3,2x4h3d =,G9.3,/,2x21hEXCITATION to n>3 OF:,
     s	43h (will be added to previous cross sections),/,21x4h1s =,
     s	G9.3,2x4h2s =,G9.3,2x4h2p =,G9.3,/,21x4h3s =,G9.3,2x4h3p =,
     s	G9.3,2x4h3d =,G9.3,//,2x17h1s EXCITATION TO:,2x4h2s =,
     s	G9.3,2x4h2p =,G9.3,/,21x4h3s =,G9.3,2x4h3p =,G9.3,2x4h3d =,
     s	G9.3,/,2x17h2s EXCITATION TO:,2x4h3s =,G9.3,2x4h3p =,
     s	G9.3,2x4h3d =,G9.3,/,2x17h2p EXCITATION TO:,2x4h3s =,G9.3,
     s	2x4h3p =,G9.3,2x4h3d =,G9.3,//,2x22hINTRASHELL EXCITATION:,
     s	3x10h2s to 2p =,G9.3,2x10h3s to 3p =,G9.3)
209	format(/,16x47h** CROSS SECTIONS HAVE BEEN ADJUSTED BY USER **)
cc ...................................................................
300	format(2x,i2.2,1h/,i2.2,1h/,i4,21x,6hETACHA,15x,
     s	3h(C),2x,8hGPS-PIIM,2x,9hJPR 06/95)
304	format(2x26hPROJECTILE: atomic number=,f4.0,2x11hincident ch,
     s	5harge=,f4.0,2x12hatomic mass=f4.0,/,12x16hincident energy=,
     s	f8.3,6h MeV/u,2x9hvelocity=,f8.3,5h (au),/,
     s	6x22hTARGET: atomic number=,f4.0,2x6hatomic,
     s	6h mass=,f4.0,2x8hdensity=,f6.3,6h g/cm3)
305	format(2x15hrelative error=,g11.4,3x9habsolute=,g11.4)
306	format(2x28hNo stopping power correction,/)
307	format(2x16hEnergy loss: S1=,f8.3,17hMeV/mg/cm at E1=,f8.3,
     s	5hMeV/u,/,10x8hand: S2=,f8.3,17hMeV/mg/cm at E2=,f8.3,5hMeV/u)
308	FORMAT(2x49hReference ("hydrogenic") cross sections in 10E-20,
     s	5h cm:,/,2x21hCAPTURE (MEC+REC) TO:,2x4h1s =,G9.3,2x4h2s =,
     s	G9.3,2x4h2p =,G9.3,/,25x4h3s =,G9.3,2x4h3p =,G9.3,2x4h3d =,
     s	G9.3,/,2x14hIONIZATION OF:,9x4h1s =,G9.3,2x4h2s =,
     s	G9.3,2x4h2p =,G9.3,/,25x4h3s =,G9.3,2x4h3p =,G9.3,2x4h3d =,
     s	G9.3,/,2x17h1s EXCITATION TO:,6x4h2s =,
     s	G9.3,2x4h2p =,G9.3,/,25x4h3s =,G9.3,2x4h3p =,G9.3,2x4h3d =,
     s	G9.3,/,2x17h2s EXCITATION TO:,6x4h3s =,G9.3,2x4h3p =,
     s	G9.3,2x4h3d =,G9.3,/,2x17h2p EXCITATION TO:,6x4h3s =,G9.3,
     s	2x4h3p =,G9.3,2x4h3d =,G9.3,/,2x22hINTRASHELL EXCITATION:,
     s	2x10h2s to 2p =,G9.3,2x10h3s to 3p =,G9.3)
cc ....................................................................
210	format('Tar.thick.    0e-       1e-       2e-       3e-',
     s	'       4e-       5e-       6e-')
211	format(1x,9h(g/cm) ,7(3x,1h(,i2,2h+),2x))
212	format('Tar.thick.    7e-       8e-       9e-       10e-',
     s	'      11e-      12e-      13e-')
213	format('Tar.thick.    14e-      15e-      16e-      17e-',
     s	'      18e-      19e-      20e-')
214	format('Tar.thick.    21e-     22e-     23e-     24e-',
     s	'     25e-     26e-     27e-     28e-')
215	format(1x,8h(g/cm),8(3x,1h(,i2,2h+),1x))
216	format('T (g/cm)  bare    1s     2s     2p     1s   1s2s',
     s	'   1s2p  1s2s  1s2p    tot')
217	format('T (g/cm)   y1s       y2s      y2p      y3s',
     s	'      y3p      y3d    Qm in   Qm out')
cc ...................................................................
	nomf='ETA06.PRN'
	open (10,file=nomf)
	if (iprt.eq.1) then
	  write (10,200) imon,iday,iyr
	  write (10,201) nomf
	  write (10,202)
	  write (10,204) zp,qp,ap,e,vu,zc,ac,rho
	  write (10,205) erel,erabs
	  if (istp.eq.0) then
	   write (10,206)
	  else
	   write (10,207) S1,E1,S2,E2
	  end if
	  write (10,208) (secs(I),I=1,37)
	  if (icor.eq.1) then
	   write (10,209)
	  end if
	  do 30 i=1,(ilp)
	  write (10,*)' '
30	  continue
	else
	  write (10,300) imon,iday,iyr
	  write (10,203)
	  write (10,304) zp,qp,ap,e,vu,zc,ac,rho
	  write (10,305) erel,erabs
	  if (istp.eq.0) then
	    write (10,306)
	  else
	    write (10,307) S1,E1,S2,E2
	  end if
	  write (10,308) (sec(I),I=1,25)
	end if
	write (10,203)
	write (10,210)
	write (10,211)ip,ip-1,ip-2,ip-3,ip-4,ip-5,ip-6
	write (10,203)
	nomf='ETA713.PRN'
	open (11,file=nomf)
	if (iprt.eq.1) then
	  write (11,200) imon,iday,iyr
	  write (11,201) nomf
	  write (11,202)
	  write (11,204) zp,qp,ap,e,vu,zc,ac,rho
	  write (11,205) erel,erabs
	  if (istp.eq.0) then
	    write (11,206)
	  else
	    write (11,207) S1,E1,S2,E2
	  end if
	  write (11,208) (secs(I),I=1,37)
	  if (icor.eq.1) then
	   write (11,209)
	  end if
	  do 31 i=1,(ilp)
	  write (11,*)' '
31	  continue
	else
	  write (11,300) imon,iday,iyr
	  write (11,203)
	  write (11,304) zp,qp,ap,e,vu,zc,ac,rho
	  write (11,305) erel,erabs
	  if (istp.eq.0) then
	    write (11,306)
	  else
	    write (11,307) S1,E1,S2,E2
	  end if
	  write (11,308) (sec(I),I=1,25)
	end if
	write (11,203)
	write (11,212)
	if (ip.ge.13) then
	  write (11,211)ip-7,ip-8,ip-9,ip-10,ip-11,ip-12,ip-13
	else
	  write (11,*) ' '
	endif
	write (11,203)
	if (ip.ge.14) then
	nomf='ETA1420.PRN'
	open (12,file=nomf)
	if (iprt.eq.1) then
	  write (12,200) imon,iday,iyr
	  write (12,201) nomf
	  write (12,202)
	  write (12,204) zp,qp,ap,e,vu,zc,ac,rho
	  write (12,205) erel,erabs
	  if (istp.eq.0) then
	    write (12,206)
	  else
	    write (12,207) S1,E1,S2,E2
	  end if
	  write (12,208) (secs(I),I=1,37)
	  if (icor.eq.1) then
	   write (12,209)
	  end if
	  do 32 i=1,(ilp)
	    write (12,*)' '
32	  continue
	else
	  write (12,300) imon,iday,iyr
	  write (12,203)
	  write (12,304) zp,qp,ap,e,vu,zc,ac,rho
	  write (12,305) erel,erabs
	  if (istp.eq.0) then
	    write (12,306)
	  else
	    write (12,307) S1,E1,S2,E2
	  end if
	  write (12,308) (sec(I),I=1,25)
	end if
	write (12,203)
	write (12,213)
	if (ip.ge.20) then
	  write (12,211)ip-14,ip-15,ip-16,ip-17,ip-18,ip-19,ip-20
	else
	  write (12,*) ' '
	endif
	write (12,203)
	end if
	if (ip.ge.21) then
	nomf='ETA2128.PRN'
	open (13,file=nomf)
	if (iprt.eq.1) then
	  write (13,200) imon,iday,iyr
	  write (13,201) nomf
	  write (13,202)
	  write (13,204) zp,qp,ap,e,vu,zc,ac,rho
	  write (13,205) erel,erabs
	  if (istp.eq.0) then
	    write (13,206)
	  else
	    write (13,207) S1,E1,S2,E2
	  end if
	  write (13,208) (secs(I),I=1,37)
	  if (icor.eq.1) then
	   write (13,209)
	  end if
	  do 33 i=1,(ilp)
	  write (13,*)' '
33	  continue
	else
	  write (13,300) imon,iday,iyr
	  write (13,203)
	  write (13,304) zp,qp,ap,e,vu,zc,ac,rho
	  write (13,305) erel,erabs
	  if (istp.eq.0) then
	    write (13,306)
	  else
	    write (13,307) S1,E1,S2,E2
	  end if
	  write (13,308) (sec(I),I=1,25)
	end if
	write (13,203)
	write (13,214)
	if (ip.ge.28) then
	  write (13,215)ip-21,ip-22,ip-23,ip-24,ip-25,ip-26,ip-27,ip-28
	else
	  write (13,*) '   '
	endif
	write (13,203)
	end if
	nomf='ETAPIED.PRN'
	open (14,file=nomf)
	if (iprt.eq.1) then
	  write (14,200) imon,iday,iyr
	  write (14,201) nomf
	  write (14,202)
	  write (14,204) zp,qp,ap,e,vu,zc,ac,rho
	  write (14,205) erel,erabs
	  if (istp.eq.0) then
	    write (14,206)
	  else
	    write (14,207) S1,E1,S2,E2
	  end if
	  write (14,208) (secs(I),I=1,37)
	  if (icor.eq.1) then
	   write (14,209)
	  end if
	  do 34 i=1,(ilp)
	    write (14,*)' '
34	  continue
	else
	  write (14,300) imon,iday,iyr
	  write (14,203)
	  write (14,304) zp,qp,ap,e,vu,zc,ac,rho
	  write (14,305) erel,erabs
	  if (istp.eq.0) then
	    write (14,306)
	  else
	    write (14,307) S1,E1,S2,E2
	  end if
	  write (14,308) (sec(I),I=1,25)
	end if
	write (14,203)
	write (14,*) ' '
	write (14,216)
	write (14,203)
	nomf='POPMEAN.PRN'
	open (15,file=nomf)
	if (iprt.eq.1) then
	  write (15,200) imon,iday,iyr
	  write (15,201) nomf
	  write (15,202)
	  write (15,204) zp,qp,ap,e,vu,zc,ac,rho
	  write (15,205) erel,erabs
	  if (istp.eq.0) then
	    write (15,206)
	  else
	    write (15,207) S1,E1,S2,E2
	  end if
	  write (15,208) (secs(I),I=1,37)
	  if (icor.eq.1) then
	   write (15,209)
	  end if
	  do 35 i=1,(ilp)
	    write (15,*)' '
35	  continue
	else
	  write (15,300) imon,iday,iyr
	  write (15,203)
	  write (15,304) zp,qp,ap,e,vu,zc,ac,rho
	  write (15,305) erel,erabs
	  if (istp.eq.0) then
	    write (15,306)
	  else
	    write (15,307) S1,E1,S2,E2
	  end if
	  write (15,308) (sec(I),I=1,25)
	end if
	write (15,203)
	write (15,*) '  '
	write (15,217)
	write (15,203)
	ild=ilgn-4
cc
cc	*******************************************************
cc	calcul des sections efficaces (ion incident) en units rduites
cc	*******************************************************
	call POPMEAN(Y)
	QM=Zp-(y1s+yl+ym)
	call CSEC(E)
220	format(1x,f8.3,1x,f7.3,6(1x,G9.3))
	do 2 I=1,26
	Sec(I)=Sec(I)*conv
2	continue
	Sec(1)=sec(1)/2.
	sec(2)=sec(2)/2.
	sec(3)=sec(3)/6.
	Sec(4)=sec(4)/2.
	sec(5)=sec(5)/6.
	sec(6)=sec(6)/10.
	sec(13)=sec(13)/2.
	sec(14)=sec(14)/6.
	sec(15)=sec(15)/2.
	sec(16)=sec(16)/6.
	sec(17)=sec(17)/10.
	sec(18)=sec(18)/2.
	sec(19)=sec(19)/6.
	sec(20)=sec(20)/10.
	sec(21)=sec(21)/2.
	sec(22)=sec(22)/6.
	sec(23)=sec(23)/10.
	sec(24)=sec(24)/6.
	sec(25)=sec(25)/6.
	sec(26)=sec(26)/10.
	Rad=rad*conv
	Rad3s=Rad3s*conv
	Rad3p1=Rad3p*0.882*conv
	Rad3p2=Rad3p*0.118*conv
	Rad3d=Rad3d*conv
	rad3s=rad3s+sec(21)
	rad3p1=rad3p1+sec(16)
	rad3p2=rad3p2+sec(19)
	rad3d=rad3d+sec(23)
	AKLL=AKLL*conv
	AKLM=AKLM*conv
	ALMM=ALMM*conv
cc	*******************************************************
cc	Debut du calcul d'integration
cc	*******************************************************
	call gettim(ih0,imi0,isec0,it0)
	write (6,160) ih0,imi0,isec0
160	format (2x,12hbegin time =,2x,i2,3h h ,i2,4h mn ,i2,2h s)
	t0=(ih0*3600+imi0*60+isec0+it0/100.)
	iboucle=0
	MINT=3
	NROOT=0
	T=0.
	TOUT=ep0
	toutc=0.
	QM0=QM
 100	dtout=(tout-toutc)/tc
	DQM=ABS((QM-QM0)*ddq)
	if((dtout.ge.1.).or.(DQM.ge.1.)) then
	  dt=tout-toutc
	  call chgt(e,zp,ac,rho,as,bs,dt,ef,qm)
	  toutc=tout
	  QM0=QM
	  call gettim(ih1,imi1,isec1,it1)
	  t1=(ih1*3600+imi1*60+isec1+it1/100.)
	  ttot=t1-t0
	  iht=ttot/3600
	  imt=(ttot-3600*iht)/60
	  tst=(ttot-3600*iht-60*imt)
	  write (6,105) iht,imt,tst
	end if
105	format (2x23hrestart integration ...,14h(elapsed time=,
     s	2x,i2,3h h ,i2,4h mn ,f5.2,3h s))
	MSTATE=1
	EPS=erel
	EWT=erabs
	LENW=8700
	LENIW=110
	X=T
cc	****************************************************
10	call EQDIF(NEQ,T,Y,F,TOUT,MSTATE,NROOT,EPS,EWT,MINT,WORK,
     s	LENW,IWORK,LENIW,F)
cc	*************** IDID=1 tant que T <= TOUT **********
	if (MSTATE.GT.2)THEN
	call message(mstate)
	go to 5000
	end if
	NSTEP=IWORK(3)
	iboucle=NSTEP
	AVGORD=WORK(3)
	do 101 IN=1,84
	if (Y(IN).lt.0.) then
	Y(IN)=0.
	end if
	YX(IN)=Y(IN)*100.
 101	continue
cc	**************** fin du calcul sur un pas ************
	X=T
cc	***********************************************
cc	calcul des probabilites des etats de charge
cc	***********************************************
	call popmean(Y)
	QM=Zp-(y1s+yl+ym)
	do 3 M=1,30
	PR(M)=0.
3	continue
	do 4 N=1,20
	PKL(N)=0.
	PM(N)=0.
4	continue
	do 5 L=64,66
	do 5 LL=67,73
	do 5 LLL=74,84
	NE3=L+LL+LLL-205+1
	PM(NE3)=PM(NE3)+Y(L)*Y(LL)*Y(LLL)
5	continue
cc-------- autoionisation K et populations K+L --------
	do 6 K=0,2
	do 6 J=0,2
	do 6 I=0,6
	N=I+J+K+1
	IC=100*I+10*J+K
	L=NUM(IC)
cc---2 e- K -----
	if (k.eq.2) then
	  PKL(N)=PKL(N)+Y(L)
cc---1 e- K -----
	elseif (k.eq.1) then
	  if ((i+j).ge.2) then
	    if(ok.gt.0.) then
	    rl=real(i+j-1)
	    corr=1./(1.+(1.-ok)*rl/(7.*ok))
	    else
	    corr=0.
	    endif
	  else
	    corr=1.
	  endif
	  PKL(N)=PKL(N)+Y(L)*corr
	  PKL(N-1)=PKL(N-1)+Y(L)*(1.-corr)
cc---0 e- K -----
	else
	  if((i+j).ge.4) then
	    if(ok.gt.0.) then
	      rl=real(i+j-1)
	      corr1=1./(1.+(1.-ok)*rl/(7.*ok))
	      corr2=1./(1.+(1.-ok)*(rl-1.)/(7.*ok))
	      corr3=1./(1.+(1.-ok)*(rl-2.)/(7.*ok))
	    else
	      corr1=0.
	      corr2=0.
	      corr3=0.
	    endif
	    PKL(N)=PKL(N)+Y(L)*corr1*corr2
	    PKL(N-1)=PKL(N-1)+Y(L)*(corr1*(1.-corr2)+corr3*(1.-corr1))
	    PKL(N-2)=PKL(N-2)+Y(L)*(1.-corr1)*(1.-corr3)
	  elseif ((i+j).ge.2) then
	    if(ok.gt.0.) then
	      rl=real(i+j-1)
	      corr=1./(1.+(1.-ok)*rl/(7.*ok))
	    else
	      corr=1.
	    endif
	    PKL(N)=PKL(N)+Y(L)*corr
	    PKL(N-1)=PKL(N-1)+Y(L)*(1.-corr)
	  else
	    PKL(N)=PKL(N)+Y(L)
	  endif
	endif
6	continue
cc-------- autoionisation L et populations K+L+M --------
	do 7 l=1,11
	do 7 m=1,19
	i=m/2
	j=(m-1)/2
	k=12-l-j
	if (k.ge.1) then
	  n=l+i
	else
	  n=2*l+m-12
	endif
	  PR(n)=PR(n)+PKL(l)*PM(m)
7	continue
	PT=0.
	QF=0.
	do 8 M=1,29
	RM=M
	PR(M)=100.*PR(M)
	PT=PT+PR(M)
	QF=QF+(Zp-RM+1.)*PR(M)/100.
8	continue
cc	********* impression des probabilites a chaque pas *****
	write (10,15) T,(PR(I),I=1,7)
	write (11,15) T,(PR(I),I=8,14)
	if (ip.ge.14) then
	write (12,15) T,(PR(I),I=15,21)
	end if
	if (ip.ge.21) then
	write (13,16) T,(PR(I),I=22,29)
	end if
	tots=yx(1)+yx(2)+yx(4)+yx(10)+yx(3)+yx(5)+yx(11)+yx(6)+yx(12)
	write (14,17) T,yx(1),yx(2),yx(4),yx(10),yx(3),yx(5),yx(11),
     s	yx(6),yx(12),tots
	write (15,18) T,y1s,y2s,y2p,y3s,y3p,y3d,QM,QF
15	format(F9.2,F9.5,6(1x,F9.5))
16	format(F9.2,F8.4,7(1x,F8.4))
17	format(F9.2,10(1x,F6.2))
18	format(F9.2,E10.3,5(E9.3),2(1x,f7.3))
	ild=ild-1
cc	***** en ttes hauts de pages si iprt=1 ***********
	if ((ild.eq.0).and.(iprt.eq.1)) then
	  write (10,203)
	  write (10,210)
	  write (10,211)ip,ip-1,ip-2,ip-3,ip-4,ip-5,ip-6
	  write (10,203)
	  write (11,203)
	  write (11,212)
	  if (ip.ge.13) then
	    write (11,211)ip-7,ip-8,ip-9,ip-10,ip-11,ip-12,ip-13
	  else
	    write (11,*) ' '
	  endif
	  write (11,203)
	  if (ip.ge.14) then
	    write (12,203)
	    write (12,213)
	    if (ip.ge.20) then
	      write (12,211)ip-14,ip-15,ip-16,ip-17,ip-18,ip-19,ip-20
	    else
	      write (12,*) ' '
	    endif
	    write (12,203)
	  end if
	  if (ip.ge.21) then
	    write (13,203)
	    write (13,214)
	    if (ip.ge.28) then
	  write (13,215)ip-21,ip-22,ip-23,ip-24,ip-25,ip-26,ip-27,ip-28
	    else
	  write (13,*) '   '
	    endif
	    write (13,203)
	  end if
	  write (14,203)
	  write (14,*) ' '
	  write (14,216)
	  write (14,203)
	  write (15,203)
	  write (15,*) ' '
	  write (15,217)
	  write (15,203)
	  ild=ilgn-4
	end if
	T=TOUT
	write(6,19) T,iboucle
19	format(2x,19hachieved thickness=,f9.2,4x,17h(iteration # for ,
     s	10hthis step=,i5,1h))
	iboucle=0
cc	********* poursuite du calcul tant que T <= EPM *****
	if (TOUT.lt.EPM) then
		if (TOUT.lt.pas0)then
cc*************** (pas0=20*ep0) ******************
		  TOUT=TOUT+ep0
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.le.0.2) then
		  TOUT=TOUT+ep0
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.1.4999) then
		  if (ep1.gt.0.05) then
		   TOUT=TOUT+0.05
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.1.9999) then
		  if (ep1.gt.0.1) then
		   TOUT=TOUT+0.1
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.4.9999) then
		  if (ep1.gt.0.2) then
		   TOUT=TOUT+0.2
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.14.999) then
		  if (ep1.gt.0.5) then
		   TOUT=TOUT+0.5
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.19.99) then
		  if (ep1.gt.1.) then
		   TOUT=TOUT+1.
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.49.99) then
		  if (ep1.gt.2.) then
		   TOUT=TOUT+2.
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.149.99) then
		  if (ep1.gt.5.) then
		   TOUT=TOUT+5.
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.199.99) then
		  if (ep1.gt.10.) then
		   TOUT=TOUT+10.
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.499.99) then
		  if (ep1.gt.20.) then
		   TOUT=TOUT+20.
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.1499.9) then
		  if (ep1.gt.50.) then
		   TOUT=TOUT+50.
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.1999.) then
		  if (ep1.gt.100.) then
		   TOUT=TOUT+100.
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.4999.) then
		  if (ep1.gt.200.) then
		   TOUT=TOUT+200.
		  else
		   TOUT=TOUT+ep1
		  end if
		   if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.14999.) then
		  if (ep1.gt.500.) then
		   TOUT=TOUT+500.
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.19999.) then
		  if (ep1.gt.1000.) then
		   TOUT=TOUT+1000.
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else if (TOUT.lt.49999.) then
		  if (ep1.gt.2000.) then
		   TOUT=TOUT+2000.
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		else
		  if (ep1.gt.5000.) then
		   TOUT=TOUT+5000.
		  else
		   TOUT=TOUT+ep1
		  end if
		  if (TOUT.gt.EPM) TOUT=EPM
		  iboucle=0.
		  goto 100
		endif
	endif
cc ************* fins de fichiers **************************
	call gettim(ih1,imi1,isec1,it1)
	write (6,161) ih1,imi1,isec1
161	format (4x,10hend time =,2x,i2,3h h ,i2,4h mn ,i2,2h s)
	t1=(ih1*3600+imi1*60+isec1+it1/100.)
	ttot=t1-t0
	iht=ttot/3600
	imt=(ttot-3600*iht)/60
	tst=(ttot-3600*iht-60*imt)
	write (6,162) iht,imt,tst
162	format (1x,13helapsed time=,2x,i2,3h h ,i2,4h mn ,f5.2,2h s)
	if(tc.lt.epm) then
	  dt=tout-toutc
	  if (dt.gt.0.) then
	    ef=e+(bs-e)*(1.-exp(-0.001*tc*as))
	    e=ef
	  end if
	end if
	write (6,163) e
163	format (35x,14hfinal energy :,1x,g10.5,7h(MeV/u))
	write (10,203)
	if (iprt.eq.0) then
	  write (10,210)
	  write (10,211)ip,ip-1,ip-2,ip-3,ip-4,ip-5,ip-6
	  write (10,203)
	end if
	write (10,160) ih0,imi0,isec0
	write (10,161) ih1,imi1,isec1
	write (10,163) e
	write (11,203)
	if (iprt.eq.0) then
	  write (11,212)
	  if (ip.ge.13) then
	    write (11,211)ip-7,ip-8,ip-9,ip-10,ip-11,ip-12,ip-13
	  endif
	  write (11,203)
	end if
	write (11,160) ih0,imi0,isec0
	write (11,161) ih1,imi1,isec1
	write (11,163) e
	if (ip.ge.14) then
	  write (12,203)
	  if (iprt.eq.0) then
	    write (12,213)
	    if (ip.ge.20) then
	      write (12,211)ip-14,ip-15,ip-16,ip-17,ip-18,ip-19,ip-20
	    endif
	    write (12,203)
	  end if
	  write (12,160) ih0,imi0,isec0
	  write (12,161) ih1,imi1,isec1
	  write (12,163) e
	  close(unit=12)
	end if
	if (ip.ge.21) then
	  write (13,203)
	  if (iprt.eq.0) then
	    write (13,214)
	    if (ip.ge.28) then
	  write (13,215)ip-21,ip-22,ip-23,ip-24,ip-25,ip-26,ip-27,ip-28
	    endif
	    write (13,203)
	  end if
	  write (13,160) ih0,imi0,isec0
	  write (13,161) ih1,imi1,isec1
	  write (13,163) e
	  close(unit=13)
	end if
	write (14,203)
	if (iprt.eq.0) then
	  write (14,216)
	  write (14,203)
	end if
	write (14,160) ih0,imi0,isec0
	write (14,161) ih1,imi1,isec1
	write (14,163) e
	write (15,203)
	if (iprt.eq.0) then
	  write (15,217)
	  write (15,203)
	end if
	write (15,160) ih0,imi0,isec0
	write (15,161) ih1,imi1,isec1
	write (15,163) e
	close(unit=10)
	close(unit=11)
	close(unit=14)
	close(unit=15)
	write(6,*) 'output data in files:'
	write(6,*) '  0 to  6 e- charge states    in ETA06.PRN'
	write(6,*) '  7 to 13 e- charge states    in ETA713.PRN'
	if (ip.ge.14) then
	write(6,*) ' 14 to 20 e- charge states    in ETA1420.PRN'
	end if
	if (ip.ge.21) then
	write(6,*) ' 21 to 28 e- charge states    in ETA2128.PRN'
	end if
	write(6,*) ' bare,1s,2s,2p,1s,1s2s,1s2p,1s2s,1s2p ions '
	write(6,*) ' and sum of these             in ETAPIED.PRN'
	write(6,*) ' mean 1s,2s,2p,3s,3p and 3d populations'
	write(6,*) '                              in POPMEAN.PRN'
	write(6,*) '  '
	write(6,*)'WARNING! Next calculation will overwrite these files'
	write(6,*)'Think to save or rename these results ! '
5000	continue
	END
cc	*********** FIN de etacha *************************
	subroutine chgt(e,zp,ac,rho,as,bs,tc,ef,qm)
	common/seceff/sec(26),cor(38),secs(38)
	common/secrad/Rad,ok,ol,Rad3s,Rad3p1,Rad3p2,Rad3d
	common/aug/AKLL,AKLM,ALMM
	common/popi/n02s,n02p,n03s,n03p,n03d,nl0,nm0
	ef=e+(bs-e)*(1.-exp(-0.001*tc*as))
	e=ef
	call CSEC(ef)
220	format(1x,f8.3,1x,f7.3,6(1x,G9.3))
c	write(16,220)ef,qm,sec(1),sec(2),sec(4),sec(7),sec(8),sec(10)
	dum=qm
	e=ef
	conv=6.023E-3/AC
	write(6,*)'Radiative and Auger yields'
	VC=(1-(1+E/931.5)**(-2))**(0.5)
	RAD=3.461E-6*(ZP**4)*AC/(RHO*VC)/2.
	RAD3s=.034891E-6*(ZP**4)*AC/(RHO*VC)/6.
	RAD3p=1.0301E-6*(ZP**4)*AC/(RHO*VC)/2.
	RAD3d=.3544E-6*(ZP**4)*AC/(RHO*VC)/6.
	if (n02p.ge.1) then
	AKLL=rad*(1./ok-1.)*n02p/(nl0*(nl0-1))
	else
	AKLL=1000.*rad
	endif
	if (nm0.ge.1) then
	AKLM=rad3p*0.882*(1./ok-1.)*n02p/(nl0*nm0)
	else
	AKLM=1000.*rad3p
	endif
	if (nm0.ge.2) then
	ALMM=(rad3s*n03s+rad3d*n03d)*(1./ol-1.)/(nm0*(nm0-1))
	else
	ALMM=1000.*rad3s
	endif
	do 1 I=1,26
	Sec(I)=Sec(I)*conv
1	continue
	Sec(1)=sec(1)/2.
	sec(2)=sec(2)/2.
	sec(3)=sec(3)/6.
	Sec(4)=sec(4)/2.
	sec(5)=sec(5)/6.
	sec(6)=sec(6)/10.
	sec(13)=sec(13)/2.
	sec(14)=sec(14)/6.
	sec(15)=sec(15)/2.
	sec(16)=sec(16)/6.
	sec(17)=sec(17)/10.
	sec(18)=sec(18)/2.
	sec(19)=sec(19)/6.
	sec(20)=sec(20)/10.
	sec(21)=sec(21)/2.
	sec(22)=sec(22)/6.
	sec(23)=sec(23)/10.
	sec(24)=sec(24)/6.
	sec(25)=sec(25)/6.
	sec(26)=sec(26)/10.
	Rad=rad*conv
	Rad3s=Rad3s*conv
	Rad3p1=Rad3p*0.882*conv
	Rad3p2=Rad3p*0.118*conv
	Rad3d=Rad3d*conv
	rad3s=rad3s+sec(21)
	rad3p1=rad3p1+sec(16)
	rad3p2=rad3p2+sec(19)
	rad3d=rad3d+sec(23)
	AKLL=AKLL*conv
	AKLM=AKLM*conv
	ALMM=ALMM*conv
	return
	end
cc	***************************************************
	subroutine popmean(u)
	dimension u(84)
	common/mean/y1s,y2s,y2p,y3s,y3p,y3d,yl,ym,ymp,ymm
	common/qmoy/ykm,yl1m,yl2m,ym1m,ym2m
cc	nombres moyens d'lectrons par sous-couche
	y3s=U(65)+2.*U(66)
	y3p=U(68)+2.*U(69)+3.*U(70)+4.*U(71)+5.*U(72)+6.*U(73)
	y3d=U(75)+2.*U(76)+3.*U(77)+4.*U(78)+5.*U(79)+6.*U(80)
	y3d=y3d+7.*U(81)+8.*U(82)+9.*U(83)+10.*U(84)
	ym=y3s+y3p+y3d
c -------- ne sert pas ? ------------------------------
	ymp=0.
	ymm=0.
	do 1 I=0,2
	do 1 J=0,6
	do 1 K=0,10
	N=I+J+K
	ymp=ymp+U(64+I)*U(67+J)*U(74+K)*N
	if (N.ge.2) then
	ymm=ymm+U(64+I)*U(67+J)*U(74+K)*N*(N-1)
	endif
1	continue
	ym1m=0.
	do 2 I=0,2
	do 2 J=0,6
	N=I+J-1
	if (N.ge.2) then
	ym1m=ym1m+U(64+I)*U(67+J)*(N-1)
	endif
2	continue
	ym2m=U(76)+2.*U(77)+3.*U(78)+4.*U(79)+5.*U(80)
	ym2m=ym2m+6.*U(81)+7.*U(82)+8.*U(83)+9.*U(84)
c------------------------------------------------------
c.....valeurs moyennes 1s, 2s, 2p ......
	y1s=0.
	y2s=0.
	y2p=0.
	do 3 N=1,63
	I=II(N)
	J=JJ(I,N)
	K=KK(I,J,N)
	y1s=y1s+K*U(N)
	y2s=y2s+J*U(N)
	y2p=y2p+I*U(N)
3	continue
	yl=y2s+y2p
c.....valeurs moyennes 1s, 2s, 2p......
	ykm=0.
	yl1m=0.
	yl2m=0.
	do 4 N=1,63
	I=II(N)
	J=JJ(I,N)
	K=KK(I,J,N)
	if(K.ge.2) then
	ykm=ykm+U(N)
	end if
	if(J.ge.2) then
	yl1m=yl1m+U(N)
	end if
	if(I.ge.2) then
	yl2m=yl2m+(I-1)*U(N)
	end if
4	continue
	return
	end
cc*********************************************************************
	function omk(z)
	dimension ok(92)
	data (ok(i),i=1,92) / 0.,0.,0.001,0.0012,
     s	.170E-02,.280E-02,.520E-02,.830E-02,.130E-01,.180E-01,.230E-01,
     s	.300E-01,.390E-01,.500E-01,.630E-01,.780E-01,.970E-01,.118,
     s	.140	 ,.163	  ,.188    ,.214    ,.243    ,.275    ,.308,
     s	.340	 ,.373	  ,.406    ,.440    ,.474    ,.507    ,.535,
     s	.562	 ,.589	  ,.618    ,.643    ,.667    ,.690    ,.710,
     s	.730	 ,.747	  ,.765    ,.780    ,.794    ,.808    ,.820,
     s	.831	 ,.843	  ,.853    ,.862    ,.870    ,.877    ,.884,
     s	.891	 ,.897	  ,.902    ,.907    ,.912    ,.917    ,.921,
     s	.925	 ,.929	  ,.932    ,.935    ,.938    ,.941    ,.944,
     s	.947	 ,.949	  ,.951    ,.953    ,.955    ,.957    ,.958,
     s	.959	 ,.961	  ,.962    ,.963    ,.964    ,.965    ,.966,
     s	.967	 ,.968	  ,.968    ,.969    ,.969    ,.970    ,.970,
     s	.971	 ,.971	  ,.972	   ,.972 /
	i=Z
	omk=ok(i)
	return
	end
cc*********************************************************************
	function oml(z)
	dimension ol(92)
	data (ol(i),i=1,92) / 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,
     s	.120E-02,.750E-03,.380E-03,.310E-03,.260E-03,.240E-03,.220E-03,
     s  .270E-03,.330E-03,.840E-03,.150E-02,.260E-02,.370E-02,.500E-02,
     s  .630E-02,.770E-02,.930E-02,.110E-01,.120E-01,.130E-01,.150E-01,
     s  .160E-01,.180E-01,.200E-01,.220E-01,.240E-01,.260E-01,.280E-01,
     s  .310E-01,.340E-01,.370E-01,.400E-01,.430E-01,.460E-01,.490E-01,
     s  .520E-01,.560E-01,.600E-01,.640E-01,.690E-01,.740E-01,.790E-01,
     s  .850E-01,.910E-01,.970E-01,.104    ,.111    ,.118    ,.125    ,
     s	.132	,.139	 ,.147	  ,.155    ,.164    ,.174    ,.182    ,
     s  .192    ,.201    ,.210    ,.220    ,.231    ,.243    ,.255    ,
     s  .268    ,.281    ,.294    ,.306    ,.320    ,.333    ,.347    ,
     s  .360    ,.373    ,.386    ,.399    ,.411    ,.424    ,.437    ,
     s	.450	,.463	 ,.476	  ,.489 /
	i=Z
	oml=ol(i)
	return
	end
cc*********************************************************************
	subroutine message(idid)
	write (6,*)'problem integrating with QDIFF'
	if (idid.eq.3) then
	write (6,*)' more than 1000 iterations have been atempted ...'
	write (6,*)' try reducing maximum step size'
	end if
	if (idid.eq.4) then
	write (6,*)' you are probably asking too much accuracy ...'
	write (6,*)' try again with larger uncertainties'
	end if
	if (idid.GT.4) then
	write (6,*)' for some reason, the problem is very stiff and',
     s	' cannot be solved with the present integration routine'
	end if
	return
	end
cc*********************************************************************
