	subroutine F(NEQ,X,U,UP)
cc	*********************************************************
cc	cration des quations diffrentielles (fonction F)
cc	*********************************************************
	dimension U(84),UP(84)
	common/etats/ICO(63)
cc--------------------------------------------------------------
cc	ICO=100*I+10*J+K
cc
cc	I= nb elec 2p , J= nb elec 2s , K= nb elec 1s
cc
cc	y1s= nb moyen e- 1s , y2s= ...etc
cc
cc	Version prenant en compte de faon non corrle
cc	la prsence d'lectrons M :
cc	- pour n=1 et 2 , 63 tats corrls du type {I,J,K}
cc	(fractions d'ions avec I e- 2p ET J e- 2s ET K e- 1s)
cc	- pour n=3 , 3+7+11 = 21 tats indpendants
cc	(fractions d'ions avec 0,1,2 (,..) e- en 3s,3p et 3d)
cc--------------------------------------------------------------
	common/seceff/sec(26),cor(26),secs(36)
	common/secrad/Rad,ok,ol,Rad3s,Rad3p1,Rad3p2,Rad3d
	common/aug/AKLL,AKLM,ALMM
	common/mean/y1s,y2s,y2p,y3s,y3p,y3d,yl,ym,ymp,ymm
cc--------------------------------------------------------------
cc	sections efficaces effectives pour n=1 & 2
cc	(seule modif pour ces tats si on tient compte de n=3)
cc--------------------------------------------------------------
	dum=x
	Ndum=NEQ
	C1s=sec(1)
	C2s=sec(2)
	C2p=sec(3)
	C3s=sec(4)
	C3p=sec(5)
	C3d=sec(6)
	D1s=sec(7)
	D2s=sec(8)
	D2p=sec(9)
	D3s=sec(10)
	D3p=sec(11)
	D3d=sec(12)
	e2s=sec(13)
	e2p=sec(14)
	e3s=sec(15)
	e3p=sec(16)
	e3d=sec(17)
	s3s=sec(18)
	s3p=sec(19)
	s3d=sec(20)
	p3s=sec(21)
	p3p=sec(22)
	p3d=sec(23)
	esp=sec(24)
	esp3=sec(25)
	epd3=sec(26)
	D2pe=D2p+(2.-y3s)*p3s+(6.-y3p)*p3p+(10.-y3d)*p3d
	D2se=D2s+(2.-y3s)*s3s+(6.-y3p)*s3p+(10.-y3d)*s3d
	D1se=D1s+(2.-y3s)*e3s+(6.-y3p)*e3p+(10.-y3d)*e3d
	C2pe=C2P+y3s*Rad3s+y3p*p3p+y3d*Rad3d+ALMM*ymm
	C2se=C2S+y3s*s3s+y3p*Rad3p2+y3d*s3d+ALMM*ymm
	C1se=C1S+y3s*e3s+y3p*Rad3p1+y3d*e3d
cc--------------------------------------------------------------
cc--------------------------------------------------------------
cc	Boucle de calcul des quations diffrentielles
cc	pour les 63 tats {1s,2s,2p}
cc--------------------------------------------------------------
	do 200 N=1,63
	I=II(N)
	J=JJ(I,N)
	K=KK(I,J,N)
	L=100*I+10*J+K
cc------------------------------------------------------------------
cc ensemble des processus de dpeuplement (changes avec n=3 inclus)
cc------------------------------------------------------------------
	UP(N)=-U(N)*((6-I)*C2Pe+(2-J)*C2Se+(2-K)*C1Se)
	UP(N)=UP(N)-U(N)*(I*D2Pe+J*D2Se+K*D1Se)
	UP(N)=UP(N)-U(N)*((2-K)*I*RAD+2*(K+J-K*J)*E2S)
	UP(N)=UP(N)-U(N)*(2*(3*K+I-K*I)*E2P)
	UP(N)=UP(N)-U(N)*(2*(3*J+I-I*J)*ESP)
cc.......... Augers KLL et KLM ....................................
cc	processus de dpeuplement
cc.................................................................
	if (K.lt.2) then
	  if (I.ge.2) then
	    UP(N)=UP(N)-U(N)*AKLL*I*(I-1)*(2-K)
	  end if
	  if (I.ge.1) then
	    UP(N)=UP(N)-U(N)*AKLM*I*ym*(2-K)
	      if (J.ge.1) then
		UP(N)=UP(N)-U(N)*AKLL*2.*I*J*(2-K)
	      end if
	  end if
	  if (J.ge.1) then
	    UP(N)=UP(N)-U(N)*AKLM*J*ym*(2-K)
	  end if
	  if (J.ge.2) then
	    UP(N)=UP(N)-U(N)*AKLL*J*(J-1)*(2-K)
	  end if
	end if
cc.................................................................
cc	processus de peuplement
cc.................................................................
	if (K.ne.0) then
cc........ Augers KLL ........................
	  if (I.le.4) then
	    M=NUM(L+199)
	    UP(N)=UP(N)+(3-K)*(I+2)*(I+1)*AKLL*U(M)
	  end if
	  if ((I.le.5).and.(J.le.1)) then
	    M=NUM(L+109)
	    UP(N)=UP(N)+(3-K)*2*(I+1)*(J+1)*AKLL*U(M)
	  end if
	  if (J.eq.0) then
	    M=NUM(L+19)
	    UP(N)=UP(N)+(3-K)*2.*AKLL*U(M)
	  end if
cc........ Augers KLM ........................
	  if (I.le.5) then
	    M=NUM(L+99)
	    UP(N)=UP(N)+(3-K)*(I+1)*ym*AKLM*U(M)
	  end if
	  if (J.le.1) then
	    M=NUM(L+9)
	    UP(N)=UP(N)+(3-K)*(J+1)*ym*AKLM*U(M)
	  end if
cc............................................
	end if
cc--------------------------------------------------------------
cc peuplements par gain si l'tat considr possde des lectrons
cc et processus inter-couches si, de plus,
cc			    l'tat considr possde des lacunes
cc--------------------------------------------------------------
cc
cc..............................................................
cc		    tat 2p
cc..............................................................
	if (I.ne.0) then
	M=NUM(L-100)
	UP(N)=UP(N)+(7-I)*C2Pe*U(M)
	if (K.ne.2) then
	M=NUM(L-99)
	UP(N)=UP(N)+(7-I)*(K+1)*E2P*U(M)
	end if
	if (J.ne.2) then
	M=NUM(L-90)
	UP(N)=UP(N)+(7-I)*(J+1)*ESP*U(M)
	end if
	end if
cc..............................................................
cc		    tat 2s
cc..............................................................
	if (J.ne.0) then
	M=NUM(L-10)
	UP(N)=UP(N)+(3-J)*C2Se*U(M)
	if (K.ne.2) then
	M=NUM(L-9)
	UP(N)=UP(N)+(3-J)*(K+1)*E2S*U(M)
	end if
	if (I.ne.6) then
	M=NUM(L+90)
	UP(N)=UP(N)+(3-J)*(I+1)*ESP*U(M)
	end if
	end if
cc..............................................................
cc		    tat 1s
cc..............................................................
	if (K.ne.0) then
	M=NUM(L-1)
	UP(N)=UP(N)+(3-K)*C1Se*U(M)
	if (I.ne.6) then
	M=NUM(L+99)
	UP(N)=UP(N)+(3-K)*(I+1)*(RAD+E2P)*U(M)
	end if
	if (J.ne.2) then
	M=NUM(L+9)
	UP(N)=UP(N)+(3-K)*(J+1)*E2S*U(M)
	end if
	end if
cc--------------------------------------------------------------
cc peuplements par ionisation si l'tat considr possde des lacunes
cc--------------------------------------------------------------
cc
cc		    etat 2p
	if (I.ne.6) then
	M=NUM(L+100)
	UP(N)=UP(N)+(1+I)*D2Pe*U(M)
	end if
cc		    etat 2s
	if (J.ne.2) then
	M=NUM(L+10)
	UP(N)=UP(N)+(1+J)*D2Se*U(M)
	end if
cc		    etat 1s
	if (K.ne.2) then
	M=NUM(L+1)
	UP(N)=UP(N)+(K+1)*D1Se*U(M)
	end if
 200	continue
cc--------------------------------------------------------------
cc	Sections efficaces effectives pour les tats 3s,3p,3d
cc--------------------------------------------------------------
	SLS=d3s+(6.-y2p)*rad3s+(2.-y2s)*s3s+(2.-y1s)*e3s+(6.-y3p)*esp3
	SLS=SLS+(2.-y1s)*yl*AKLM
	SLP=d3p+(6.-y2p)*p3p+(2.-y2s)*rad3p2+(2.-y1s)*rad3p1
	SLP=SLP+(2.-y3s)*esp3+(10.-y3d)*epd3
	SLP=SLP+(2.-y1s)*yl*AKLM
	SLD=d3d+(6.-y2p)*rad3d+(2.-y2s)*s3d+(2.-y1s)*e3d+(6.-y3p)*epd3
	SLD=SLD+(2.-y1s)*yl*AKLM
	SGS=c3s+y2p*p3s+y2s*s3s+y1s*e3s+y3p*esp3
	SGP=c3p+y2p*p3p+y2s*s3p+y1s*e3p+y3s*esp3+y3d*epd3
	SGD=c3d+y2p*p3d+y2s*s3d+y1s*e3d+y3p*epd3
cc--------------------------------------------------------------
cc	quations diffrentielles pour l'volution des populations
cc	en 3s,3p et 3d :
cc			64  66 -> tat 3s avec 0,1 ou 2 e-
cc			67  73 -> tat 3p avec 0,1 ... 6 e-
cc			74  84 -> tat 3d avec 0,1 ... 10 e-
cc--------------------------------------------------------------
	UP(64)=-U(64)*2.*SGS+U(65)*SLS
	UP(65)=-U(65)*(SGS+SLS)+U(64)*2.*SGS +U(66)*2.*SLS
	UP(66)=-U(66)*2.*SLS+U(65)*SGS
cc
	UP(67)=-U(67)*(6.*SGP)+U(68)*1.*SLP
	UP(68)=-U(68)*(5.*SGP+1.*SLP)+U(67)*6.*SGP +U(69)*2.*SLP
	UP(69)=-U(69)*(4.*SGP+2.*SLP)+U(68)*5.*SGP +U(70)*3.*SLP
	UP(70)=-U(70)*(3.*SGP+3.*SLP)+U(69)*4.*SGP +U(71)*4.*SLP
	UP(71)=-U(71)*(2.*SGP+4.*SLP)+U(70)*3.*SGP +U(72)*5.*SLP
	UP(72)=-U(72)*(1.*SGP+5.*SLP)+U(71)*2.*SGP +U(73)*6.*SLP
	UP(73)=-U(73)*(6.*SLP)+U(72)*1.*SGP
cc
	UP(74)=-U(74)*(10.*SGD)+U(75)*1.*SLD
	UP(75)=-U(75)*(9.*SGD+1.*SLD)+U(74)*10.*SGD +U(76)*2.*SLD
	UP(76)=-U(76)*(8.*SGD+2.*SLD)+U(75)*9.*SGD +U(77)*3.*SLD
	UP(77)=-U(77)*(7.*SGD+3.*SLD)+U(76)*8.*SGD +U(78)*4.*SLD
	UP(78)=-U(78)*(6.*SGD+4.*SLD)+U(77)*7.*SGD +U(79)*5.*SLD
	UP(79)=-U(79)*(5.*SGD+5.*SLD)+U(78)*6.*SGD +U(80)*6.*SLD
	UP(80)=-U(80)*(4.*SGD+6.*SLD)+U(79)*5.*SGD +U(81)*7.*SLD
	UP(81)=-U(81)*(3.*SGD+7.*SLD)+U(80)*4.*SGD +U(82)*8.*SLD
	UP(82)=-U(82)*(2.*SGD+8.*SLD)+U(81)*3.*SGD +U(83)*9.*SLD
	UP(83)=-U(83)*(1.*SGD+9.*SLD)+U(82)*2.*SGD +U(84)*10.*SLD
	UP(84)=-U(84)*(10.*SLD)+U(83)*1.*SGD
cc
cc........... AUGERS LMM .......................................
	AL=ALMM*(8.-yl)
	ysp=2.*(y3s+y3p)
	ysd=2.*(y3s+y3d)
	ypd=2.*(y3p+y3d)
cc.................................................
c
	UP(64)=UP(64)+AL*(+U(65)*1.*ypd+U(66)*2.)
	UP(65)=UP(65)+AL*(-U(65)*1.*ypd+U(66)*2.*ypd)
	UP(66)=UP(66)+AL*(-U(66)*2.*(ypd+1.))
c
	UP(67)=UP(67)+AL*(+U(68)*1.*ysd+U(69)*2.)
	UP(68)=UP(68)+AL*(-U(68)*1.*(ysd+0.)+U(69)*2.*ysd+U(70)*6. )
	UP(69)=UP(69)+AL*(-U(69)*2.*(ysd+1.)+U(70)*3.*ysd+U(71)*12.)
	UP(70)=UP(70)+AL*(-U(70)*3.*(ysd+2.)+U(71)*4.*ysd+U(72)*20.)
	UP(71)=UP(71)+AL*(-U(71)*4.*(ysd+3.)+U(72)*5.*ysd+U(73)*30.)
	UP(72)=UP(72)+AL*(-U(72)*5.*(ysd+4.)+U(73)*6.*ysd)
	UP(73)=UP(73)+AL*(-U(73)*6.*(ysd+5.))
c
	UP(74)=UP(74)+AL*(+U(75)*1.*ysp+U(76)*2.)
	UP(75)=UP(75)+AL*(-U(75)*1.*(ysp+0.)+U(76)*2.*ysp+U(77)*6. )
	UP(76)=UP(76)+AL*(-U(76)*2.*(ysp+1.)+U(77)*3.*ysp+U(78)*12.)
	UP(77)=UP(77)+AL*(-U(77)*3.*(ysp+2.)+U(78)*4.*ysp+U(79)*20.)
	UP(78)=UP(78)+AL*(-U(78)*4.*(ysp+3.)+U(79)*5.*ysp+U(80)*30.)
	UP(79)=UP(79)+AL*(-U(79)*5.*(ysp+4.)+U(80)*6.*ysp+U(81)*42.)
	UP(80)=UP(80)+AL*(-U(80)*6.*(ysp+5.)+U(81)*7.*ysp+U(82)*56.)
	UP(81)=UP(81)+AL*(-U(81)*7.*(ysp+6.)+U(82)*8.*ysp+U(83)*72.)
	UP(82)=UP(82)+AL*(-U(82)*8.*(ysp+7.)+U(83)*9.*ysp+U(84)*90.)
	UP(83)=UP(83)+AL*(-U(83)*9.*(ysp+8.)+U(84)*10.*ysp)
	UP(84)=UP(84)+AL*(-U(84)*10.*(ysp+9.))
c
	end
cc******************************************************************
	subroutine ini(ICO)
cc...............................................................
c	Initialisation du tableau de codes ICO(n)
cc...............................................................
	dimension ICO(63)
	n=0
	DO 31 i=0,6
	DO 31 j=0,2
	DO 31 k=0,2
	n=n+1
	ICO(n)=i*100+j*10+k
 31	continue
	return
	end
cc****************************************************************
	function num(NCO)
	common /etats/ICO(63)	
	I=0
21      I=I+1
	if (ICO(I).NE.nco) goto 21
	num=I
	return
	end
CC      *********************************************************
	function II(num)
	common /etats/ICO(63)
	II=ICO(num)/100
	return
	end
CC      *********************************************************
	function JJ(I,num)
	common /etats/ICO(63)
	JJ=(ICO(num)-I*100)/10
	return
	end
CC      *********************************************************
	function KK(I,J,num)
	common /etats/ICO(63)
	KK=(ICO(num)-I*100-J*10)
	return
	end

