	subroutine sex2(s3s,s3p,s3d,p3s,p3p,p3d,e2s4,e2p4)
cc	     Version du 02/03/94 simplifie pour eta3
cc	version avec makefile utilisant la routine d'intgration INTG
cc*********************************************************************
cc	    Calcule les sections efficaces d'xcitation 2l-3l' et 2l-4l'
cc	    dans l'approximation PWBA avec facteurs d'crantage et
cc	    d'anticrantage dans le modle de Thomas-Fermi
cc	Les facteurs de forme sont calculs en fonction de la variable
cc	rduite k = q/Zp (q en u.a.)
cc
cc	Les rsultats sont donns en units de 10-20 cm
cc*********************************************************************
	INTEGER LIMIT,LENW
	PARAMETER(LIMIT=100,LENW=LIMIT*4)
	REAL BOUND,EPSABS,EPSREL,ABSERR,RESULT,WORK(LENW)
	real*8 sig1,rn,qmin
	INTEGER INF,NEVAL,IER,LAST,IWORK(LIMIT)
	EXTERNAL FEX2
c**********************************************************************
	dimension sec(8)
	character erfi*12
	common/par4/zk,zl1,zl2,zm1,zm2,tetak,tetal1,tetal2,tetam1,tetam2
	common /don/zp,E,zt
	common /nm/ rn,coa
	common/corr/ibin
	erfi='messerr.fil'
	bet=(1.-(1.+E/931.5)**(-2.))**(0.5)
	vu=137.036*bet
	zp2=zl2/2
	if (vu.gt.zp2) then
	coa=(vu**2.-zp2**2.)/vu**2.
	else
	coa=0.
	endif
cc****************************
cc******integration***********
	do 20 n=1,8
	rn=dble(n)
cc**********************************
cc correction pour effet energie liaison:
cc**********************************
	if (ibin.eq.1) then
	y=4.*vu/(zl2*tetal2)
	g=1.+9.*y+34.7*y**2.+81.2*y**3.+112.*y**4.
	g=g+93.5*y**5.+46.6*y**6.+12.9*y**7.+1.549*y**8.
	g=g/(1.+y)**9.
	epsi=(1+zt*g/(zl2*tetal2))**2.
	else
	epsi=1.
	end if
cc****************************
	if(n.le.6) then
	qmin=dble(epsi*(zl2*tetal2/(137.036*2.*bet))*(5./36.))
	else
	qmin=dble(epsi*(zl2*tetal2/(137.036*2.*bet))*(3./16.))
	endif
	BOUND = qmin
	INF = 1
	EPSABS = 0.0
	EPSREL = 1.E-4
c*************************************************
	CALL INTG(FEX2,BOUND,INF,EPSABS,EPSREL,RESULT,ABSERR,NEVAL,
     *	  IER,LIMIT,LENW,LAST,IWORK,WORK)
	sig1=RESULT
	if (ier.gt.0) then
	open(unit=9,file=erfi,status='unknown')
	write(9,*)' n= ',n,'  ier= ',ier
	write(9,*)' result= ',result,' abserr= ',abserr
	close(unit=9)
	end if
c*************************************************
	sec(n)=sig1*(1.874)*zt*zt/(zl2*zl2*bet*bet)
20	continue
	s3s=sec(1)
	s3p=sec(2)
	s3d=sec(3)
	p3s=sec(4)
	p3p=sec(5)
	p3d=sec(6)
	e2s4=2.56*sec(7)
	e2p4=2.56*sec(8)
	return
	end
cc*************************************************************
	real function FEX2(x)
	real*8 q,scf,stf,corr,fact,bp,rn
	common/par4/zk,zl1,zl2,zm1,zm2,tetak,tetal1,tetal2,tetam1,tetam2
	common /don/zp,E,zt
	common /nm/ rn,coa
	scf=dble(1.13*zt**(1./3.))
	q=dble(x*zl2)
	stf=(scf)/(q)
	atf=(q)/(scf)
	corr=dble(1./(1.+stf**2.)**2.)
	corr=corr+coa*((1.-(1./(1.+atf**2.)**2.))/zt)
cc*********************************************************************
	bp=dble(x)
	if (rn.eq.1) then
cc 2s->3s
	fact=2.**18.*3.**7.*bp/(25.+36.*bp**2.)**10.
	fact=fact*(2875.-6984.*bp**2.+3888.*bp**4.)**2.
	elseif (rn.eq.2) then
cc 2s->3p
	fact=2.*27648.**2./(bp*(25.+36.*bp**2.)**10.)
	fact=fact*(-625.+5040.*bp**2.-3888.*bp**4.)**2.
	elseif (rn.eq.3) then
cc 2s->3d
	fact=2.*65536.**2.*3.**7.*bp/(25.+36.*bp**2.)**10.
	fact=fact*(-25.+18.*bp**2.)**2.
	elseif (rn.eq.4) then
cc 2p->3s
	fact=2.**16.*3.**7./(bp*(25.+36.*bp**2.)**10.)
	fact=fact*(625.-14040.*bp**2.+11664.*bp**4.)**2.
	elseif (rn.eq.5) then
cc 2p->3p
	fact=2.**25.*3.**9.*bp/(25.+36.*bp**2.)**10.
	fact=fact*(6875.-23400.*bp**2.+34992.*bp**4.)
	elseif (rn.eq.6) then
cc 2p->3d
	fact=2.**24.*3.**6.*5.**2./(bp*(25.+36.*bp**2.)**10.)
	fact=fact*(3125.-5400.*bp**2.+27216.*bp**4.)
	elseif (rn.eq.7) then
cc 2s->4
	fact=405.+5120.*bp**2.+98816.*bp**4.
	fact=fact-163840.*bp**6.+65536.*bp**8.
	fact=fact*2.**20./(bp*(9.+16.*bp**2.)**9.)
	else
cc 2p->4
	fact=94041.+3149280.*bp**2.+11093760.*bp**4.
	fact=fact+30031872.*bp**6.+171376640.*bp**8.
	fact=fact-169869312.*bp**10.+150994944.*bp**12.
	fact=fact*4194304./(bp*(9+16.*bp**2.)**12.)
	end if
	FEX2=fact*corr
	return
	end
cc*********************************************************************
	subroutine sex3(e3s4,e3p4,e3d4)
cc	     Version du 25/01/95 simplifie pour eta3
cc	version avec makefile utilisant la routine d'intgration INTG
cc*********************************************************************
cc	  Calcule les sections efficaces d'xcitation 3l-4l'
cc	    dans l'approximation PWBA avec facteurs d'crantage et
cc	    d'anticrantage dans le modle de Thomas-Fermi
cc	Les facteurs de forme sont calculs en fonction de la variable
cc	rduite k = q/Zp (q en u.a.)
cc
cc	Les rsultats sont donns en units de 10-20 cm
cc*********************************************************************
	INTEGER LIMIT,LENW
	PARAMETER(LIMIT=100,LENW=LIMIT*4)
	REAL BOUND,EPSABS,EPSREL,ABSERR,RESULT,WORK(LENW)
	real*8 sig1,rn,qmin
	INTEGER INF,NEVAL,IER,LAST,IWORK(LIMIT)
	EXTERNAL FEX3
c**********************************************************************
	dimension sec(3)
	character erfi*12
	common/par4/zk,zl1,zl2,zm1,zm2,tetak,tetal1,tetal2,tetam1,tetam2
	common /don/zp,E,zt
	common /nm/ rn,coa
	common/corr/ibin
	erfi='messerr.fil'
	bet=(1.-(1.+E/931.5)**(-2.))**(0.5)
	vu=137.036*bet
	zp3=zm2/3
	if (vu.gt.zp3) then
	coa=(vu**2.-zp3**2.)/vu**2.
	else
	coa=0.
	endif
cc******integration***********
	do 20 n=1,3
	rn=dble(n)
cc**********************************
cc correction pour effet energie liaison:
cc**********************************
	if (ibin.eq.1) then
	y=18.*vu/(zm2*tetam2)
	g=(1.+5.*y+7.14*y**2.+4.27*y**3.+0.947*y**4.)/(1.+y)**5.
	epsi=(1+zt*g/(zm2*tetam2))**2.
	else
	epsi=1.
	end if
cc****************************
	qmin=dble(epsi*(zm2*tetam2/(137.036*2.*bet))*(7./144.))
	BOUND = qmin
	INF = 1
	EPSABS = 0.0
	EPSREL = 1.E-4
c*************************************************
	CALL INTG(FEX3,BOUND,INF,EPSABS,EPSREL,RESULT,ABSERR,NEVAL,
     *	  IER,LIMIT,LENW,LAST,IWORK,WORK)
	sig1=RESULT
	if (ier.gt.0) then
	open(unit=9,file=erfi,status='unknown')
	write(9,*)' n= ',n,'  ier= ',ier
	write(9,*)' result= ',result,' abserr= ',abserr
	close (unit=9)
	end if
c*************************************************
	sec(n)=sig1*(1.874)*zt*zt/(zm2*zm2*bet*bet)
20	continue
	e3s4=1.7*sec(1)
	e3p4=1.7*sec(2)
	e3d4=1.7*sec(3)
	return
	end
cc*************************************************************
	real function FEX3(x)
	real*8 q,scf,stf,corr,fact,bp,rn
	common/par4/zk,zl1,zl2,zm1,zm2,tetak,tetal1,tetal2,tetam1,tetam2
	common /don/zp,E,zt
	common /nm/ rn,coa
	scf=dble(1.13*zt**(1./3.))
	q=dble(x*zm2)
	stf=(scf)/(q)
	atf=(q)/(scf)
	corr=dble(1./(1.+stf**2.)**2.)
	corr=corr+coa*((1.-(1./(1.+atf**2.)**2.))/zt)
cc*********************************************************************
	bp=dble(x)
	if (rn.eq.1) then
cc 3s->4
	fact=4250070125.+110475272992.*bp**2.
	fact=fact+251535456000.*bp**4.
	fact=fact-8858287816704.*bp**6.
	fact=fact+30668348915712.*bp**8.
	fact=fact-29926726041600.*bp**10.
	fact=fact+8916100448256.*bp**12.
	fact=fact*18345885696./(bp*(49.+144.*bp**2.)**11.)
	elseif (rn.eq.2) then
cc 3p->4
	fact=17287767714049.+93857970278016.*bp**2.
	fact=fact+14537737167528960.*bp**4.-202983558664126464.*bp**6.
	fact=fact+1282657963747442688.*bp**8.
	fact=fact-3840965426087460864.*bp**10.
	fact=fact+5938158562940289024.*bp**12.
	fact=fact-4406408170331701248.*bp**14.
	fact=fact+1663958330055327744.*bp**16.
	fact=fact*2.**30.*3.**6./(bp*(49.+144.*bp**2.)**14.)
	else
cc 3d->4
	fact=3913158201197.+2413468527456.*bp**2.
	fact=fact-161336060589312.*bp**4.
	fact=fact+10278120083374080.*bp**6.
	fact=fact-63716725109882880.*bp**8.
	fact=fact+202385944901320704.*bp**10.
	fact=fact-145466178813296640.*bp**12.
	fact=fact+68475651442606080.*bp**14.
	fact=fact*25048249270272./(5.*bp*(49.+144.*bp**2.)**14.)
	end if
	FEX3=fact*corr
	return
	end
cc*********************************************************************
