	subroutine sexi(e2s,e2p,e3s,e3p,e3d,es4)
cc	     Version du 02/03/94 simplifie pour eta3
cc	version avec makefile utilisant la routine d'intgration INTG
cc*********************************************************************
cc	    Calcule les sections efficaces d'xcitation 1s-2s, 1s-2p et
cc	1s-n dans l'approximation PWBA avec:
cc	    -facteurs de forme analytiques d'Anholt
cc	    -facteurs d'crantage et d'anticrantage dans le modle
cc	     de Thomas-Fermi
cc	Les facteurs de forme sont calculs en fonction de la variable
cc	rduite k =  q/Zp (q en u.a.)
cc
cc	Les rsultats sont donns en units de 10-20 cm
cc*********************************************************************
	INTEGER LIMIT,LENW
	PARAMETER(LIMIT=100,LENW=LIMIT*4)
	REAL BOUND,EPSABS,EPSREL,ABSERR,RESULT,WORK(LENW)
	real*8 sig1,rn,qmin
	INTEGER INF,NEVAL,IER,LAST,IWORK(LIMIT)
	EXTERNAL FEX
c**********************************************************************
	character erfi*12
	common/par4/zk,zl1,zl2,zm1,zm2,tetak,tetal1,tetal2,tetam1,tetam2
	common /don/zp,E,zt
	common /nn/ rn,ll,coa
	common/corr/ibin
	erfi='messerr.fil'
	bet=(1.-(1.+E/931.5)**(-2.))**(0.5)
	vu=137.036*bet
	if (vu.gt.zk) then
	coa=(vu**2.-zk**2.)/vu**2.
	else
	coa=0.
	endif
	nmin=2
	nmax=10
	som1=0.
	so41=0.
cc****************************
cc******integration***********
	do 20 n=nmin,nmax
	if (n.eq.2) then
	    ll=1
	end if
	if (n.eq.3) then
	    ll=4
	end if
	if (n.gt.3) then
	    ll=7
	end if
21	rn=dble(n)
cc**********************************
cc correction pour effet energie liaison:
cc**********************************
	if(ibin.eq.1) then
	y=2.*vu/(zk*tetak)
	g=(1.+5.*y+7.14*y**2.+4.27*y**3.+0.947*y**4.)/(1.+y)**5.
	epsi=(1+zt*g/(zk*tetak))**2.
	else
	epsi=1.
	end if
cc****************************
	qmin=dble(epsi*(zk*tetak/(137.036*2.*bet))*(1.-1./(rn*rn)))
	BOUND = qmin
	INF = 1
	EPSABS = 0.0
	EPSREL = 1.E-4
c*************************************************
	CALL INTG(FEX,BOUND,INF,EPSABS,EPSREL,RESULT,ABSERR,NEVAL,
     *	  IER,LIMIT,LENW,LAST,IWORK,WORK)
	sig1=RESULT
	if (ier.gt.0) then
	open(unit=9,file=erfi,status='unknown')
	write(9,*)' n= ',n,'  ier= ',ier
	write(9,*)' result= ',result,' abserr= ',abserr
	close(unit=9)
	end if
c*************************************************
	sec1=sig1*(1.874)*zt*zt/(zk*zk*bet*bet)
	if(ll.eq.3.or.ll.eq.7) then
	som1=som1+sec1
	end if
	if (ll.lt.3) then
	    if(ll.eq.1) e2s=sec1
	    if(ll.eq.2) e2p=sec1
	ll=ll+1
	go to 21
	end if
	if (ll.gt.3.and.ll.lt.7) then
	    if(ll.eq.4) e3s=sec1
	    if(ll.eq.5) e3p=sec1
	    if(ll.eq.6) e3d=sec1
	ll=ll+1
	go to 21
	end if
	if (n.ge.4) then
	so41=so41+sec1
	end if
20	continue
	so41=so41+4.52*sec1
	es4=so41
	return
	end
cc*************************************************************
	real function FEX(x)
	real*8 q,scf,stf,corr,fact,bp,rn
	common/par4/zk,zl1,zl2,zm1,zm2,tetak,tetal1,tetal2,tetam1,tetam2
	common /don/zp,E,zt
	common /nn/ rn,ll,coa
	scf=dble(1.13*zt**(1./3.))
	q=dble(x*zk)
	stf=(scf)/(q)
	atf=(q)/(scf)
	corr=dble(1./(1.+stf**2.)**2.)
	corr=corr+coa*dble((1.-(1./(1.+atf**2.)**2.))/zt)
cc*********************************************************************
	bp=dble(x)
	if (ll.eq.1) then
	   fact=64.*bp/(bp*bp+9./4.)**6.
	elseif (ll.eq.2) then
	   fact=144./(bp*(bp*bp+9./4.)**6.)
	elseif (ll.eq.4) then
	   fact=1119744.*bp*(16.+27.*bp*bp)**2./(9.*bp*bp+16.)**8.
	elseif (ll.eq.5) then
	   fact=2985984.*(16.+27.*bp*bp)**2./(bp*(9.*bp*bp+16.)**8.)
	elseif (ll.eq.6) then
	   fact=573308928.*bp/(9.*bp*bp+16.)**8.
	else
	   fact=(512./(3.*rn*rn*rn))*(3.*bp*bp+1.-1./(rn*rn))
	   fact=fact*(bp*bp+(1.-1./rn)**2.)**(rn-3.)
	   fact=fact/(bp*(bp*bp+(1.+1./rn)**2.)**(rn+3.))
	end if
	FEX=fact*corr
	return
	end
cc*********************************************************************

